/*
 File: enumerate_T_alphabet.h
 Date and Time: Fri Jan 30 18:55:09 2015 
*/
#ifndef __enumerate_T_alphabet_h__
#define __enumerate_T_alphabet_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "o2_externs.h"
  
// monolithic grammar: no thread
extern yacco2::State S1_Cenumerate_T_alphabet;
namespace NS_enumerate_T_alphabet {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[5];
};
class Cenumerate_T_alphabet: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Renumerate_T_alphabet_ = 569//start_of_rule_list + 0
    ,rhs1_Renumerate_T_alphabet_ = 1
   ,R_Renum_lrk_ = 570//start_of_rule_list + 2
    ,rhs1_Renum_lrk_ = 2
   ,R_Renum_rc_ = 571//start_of_rule_list + 4
    ,rhs1_Renum_rc_ = 3
   ,R_Renum_T_ = 572//start_of_rule_list + 6
    ,rhs1_Renum_T_ = 4
   ,R_Renum_err_ = 573//start_of_rule_list + 8
    ,rhs1_Renum_err_ = 5
  };
  //no of la sets = 1
  //no of states = 5
  Cenumerate_T_alphabet();
  ~Cenumerate_T_alphabet();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[6];
  
    public:
		NS_yacco2_terminals::T_enum_phrase* enum_phrase_;
  
 };
struct Renumerate_T_alphabet;
struct Renum_lrk;
struct Renum_rc;
struct Renum_T;
struct Renum_err;
struct Renumerate_T_alphabet:public yacco2::CAbs_lr1_sym {
  Renumerate_T_alphabet(yacco2::Parser* P);
  public:
  void sr1();
};

struct Renum_lrk:public yacco2::CAbs_lr1_sym {
  Renum_lrk(yacco2::Parser* P);
  public:
  void sr1();
};

struct Renum_rc:public yacco2::CAbs_lr1_sym {
  Renum_rc(yacco2::Parser* P);
  public:
  void sr1();
};

struct Renum_T:public yacco2::CAbs_lr1_sym {
  Renum_T(yacco2::Parser* P);
  public:
  void sr1();
};

struct Renum_err:public yacco2::CAbs_lr1_sym {
  Renum_err(yacco2::Parser* P);
  public:
  void sr1();
};

} // end of namespace

#endif
